Subject: Re: [PATCH v2] ipv6: Fix protocol resubmission

From: Josh Hunt <[email-masked]>
Date: Tue, 02 Jun 2015 09:32:09 -0500

On 05/29/2015 09:37 PM, Josh Hunt wrote:
> On 05/29/2015 04:48 PM, Tom Herbert wrote:
>> Hi Josh,
>>
>> Why did you need to move the resubmit label?
>
> Grabbing nhoff out of the skb's cb didn't seem relevant anymore, unless
> we're requiring the decapsulating code to update the control block
> before it returns. Also, since we are returning nexthdr with the return
> value it seems unnecessary to go through that work when we already have it.
>
> Not that there has to be symmetry here, but for example, the v4 code
> doesn't look up the protocol field again in the inner ip header. It just
> uses the protocol value returned from the protocol handler.
>
> Also, I'm skipping the pskb_pull(), which I assumed was left up to the
> decapsulating code to setup the data pointer properly before returning.
> Again, this is how the v4 code behaves.
>
> The only thing left is the idev which I'm not sure about. Could that
> change b/t calls?
>
Tom

Do you think the above is incorrect and we should just leave the 
resubmit label where it currently is? If so, do you think we should just 
bypass the nhoff/nexthdr checks and use the nexthdr value returned by 
the protocol handler?

Thanks
Josh